;------------------------------------------------------;
; Cluster Fish - by Ladida			       ;
; Meant to be a replacement of the normal Layer 3 fish ;
; Edit of Roy's original Spike Hell sprite	       ;
;------------------------------------------------------;

!FishTile = $1D	;Tile # of the rain. 16x16


OAMStuffFish:
db $20,$24,$28,$2C,$80,$84,$88,$8C,$B0,$B4,$B8,$BC,$C0,$C4,$C8,$CC,$E4,$E8,$EC,$F0 ; These are all in $02xx

FishProperties:
db $34,$36,$38,$3A,$34,$36,$38,$3A,$34,$36,$38,$3A,$34,$36,$38,$3A,$34,$36,$38,$3A ; Properties table, per sprite. YXPPCCCT.


IncrementByOneFish:
LDA $1E02,y                     ; \ Increment Y position of sprite.
INC A                           ;  |
STA $1E02,y                     ;  |
SEC                             ;  | Check Y position relative to screen border Y position.
SBC $1C                         ;  | If equal to #$F0...
CMP #$F0                        ;  |
BNE ReturnAndSuchFish           ;  |
LDA #$01                        ;  | Appear.
STA $1E2A,y                     ; /

ReturnAndSuchFish:
RTS

Main:				;The code always starts at this label in all sprites.
LDA $1E2A,y                     ; \ If meant to appear, skip sprite intro code.
BEQ IncrementByOneFish		; /

SkipIntroFish:
LDA $9D				; \ Don't move if sprites are supposed to be frozen.
BNE ImmobileFish		; /

LDA $1E16,y
CLC
ADC #$FF
STA $1E16,y

ImmobileFish:                   ; OAM routine starts here.
LDX.w OAMStuffFish,y 		; Get OAM index.
LDA $1E02,y			; \ Copy Y position relative to screen Y to OAM Y.
SEC                             ;  |
SBC $1C				;  |
STA $0201,x			; /
LDA $1E16,y			; \ Copy X position relative to screen X to OAM X.
SEC				;  |
SBC $1A				;  |
STA $0200,x			; /
LDA #!FishTile			; \ Tile
STA $0202,x                     ; /
LDA FishProperties,y
STA $0203,x
PHX
TXA
LSR
LSR
TAX
LDA #$02
STA $0420,x
PLX
LDA $18BF
ORA $1493
BEQ ReturnToTheChocolateFishWhatever            ; Change BEQ to BRA if you don't want it to disappear at generator 2, sprite D2.
LDA $0201,x
CMP #$F0                                    	; As soon as the sprite is off-screen...
BCC ReturnToTheChocolateFishWhatever
LDA #$00					; Kill it.
STA $1892,y					;

ReturnToTheChocolateFishWhatever:
RTS
